#ifndef __GAME_H__
#define __GAME_H__

void TitleProc(void);
void GameStartProc(void);
void GameProc(void);
void GameClearProc(void);
void GameOverProc(void);

void Wait(void);
void InitGame(void);
void MainGame(void);

void DrawTitle(int i);

void CheckClear(void);
void CheckOver(void);

void InitChara(void);
void InitMissile(void);
void InitEnemy(void);
void InitMissileEnemy(void);
void InitBlock(void);

void MoveChara(void);
void MoveMissile(void);
void MoveEnemy(void);
void MoveMissileEnemy(void);
void DrawBlock(void);

void DeleteMissile(int i);
void DeleteEnemy(int i);
void DeleteMissileEnemy(int i);
void DeleteChara(void);
void DeleteBlock(int i);

void GoMissile(int x,int y);
void GoMissileEnemy(int x,int y);

int HitChara(void);

int NumCheckEnemy(void);

int GetMx(int i);
int GetMy(int i);
int GetEx(int i);
int GetEy(int i);
int GetCx(void);
int GetCy(void);
int GetMEx(int i);
int GetMEy(int i);
int GetBx(int i);
int GetBy(int i);

void CheckHit(void);
bool CheckHitNormal(int ax,int ay,int bx,int by);
bool CheckHitBlock(int ax,int ay,int bx,int by);
bool CheckHitMissile(int ax,int ay,int bx,int by);

#define GAME_STATE_TITLE 0
#define GAME_STATE_START 1
#define GAME_STATE_GAME  2
#define GAME_STATE_CLEAR 3
#define GAME_STATE_OVER  4


#define CHARA_X      300		//@̏W̐ݒ
#define CHARA_Y      440
#define CHARA_NUM      3		//@̐
#define CHARA_MOVE     4
#define CHARA_LIMITR 600		//@xW̌E
#define CHARA_LIMITL  10

#define MISSILE_MAX    1		//xɏo~TC̐
#define MISSILE_MOVE   8
#define MISSILE_LIMIT 20		//~TC̏yW
#define COUNT_M       10

#define ENEMY_LINEX   10 
#define ENEMY_LINEY    5
#define ENEMY_MAX     50
#define ENEMY_MOVE    16
#define ENEMY_MOVEY   16
#define ENEMY_LIMITR 590 
#define ENEMY_LIMITL  20

#define SPACING_X 48
#define SPACING_Y 48
#define SPACING_A 20

#define BLOCK_MAX   4
#define BLOCK_NUM 120

#define ME_MAX     3
#define ME_MOVE    4
#define ME_LIMIT 460

#define HIT     16
#define RANDOM 180


#endif
